---
title: SVG fonts
slug: Web/SVG/Tutorial/SVG_fonts
tags:
  - Advanced
  - NeedsUpdate
  - SVG
  - 'SVG:Tutorial'
---
<p>{{ PreviousNext("Web/SVG/Tutorial/Filter_effects", "Web/SVG/Tutorial/SVG_Image_Tag") }}</p>

<p>When SVG was specified, support for web fonts was not widespread in browsers. Since accessing the correct font file is however crucial for rendering text correctly, a font description technology was added to SVG to provide this ability. It was not meant for compatibility with other formats like PostScript or OTF, but rather as a simple means of embedding glyph information into SVG when rendered.</p>

<div class="note"><strong>SVG Fonts are currently supported only in Safari and Android Browser.</strong><br>
Internet Explorer <a href="http://blogs.msdn.com/b/ie/archive/2010/08/04/html5-modernized-fourth-ie9-platform-preview-available-for-developers.aspx">hasn't considered implementing this</a>, the functionality has been <a href="https://www.chromestatus.com/feature/5930075908210688">removed from Chrome 38</a> (and Opera 25) and Firefox has <a class="link-https" href="https://bugzilla.mozilla.org/show_bug.cgi?id=119490">postponed its implementation indefinitely</a> to concentrate on <a href="/en/WOFF" title="en/About WOFF">WOFF</a>. Other tools however like the <a class="external" href="http://www.adobe.com/svg/viewer/install/">Adobe SVG Viewer</a> plugin, Batik and parts of Inkscape support SVG font embedding.</div>

<p>The base for defining an SVG font is the {{ SVGElement("font") }} element.</p>

<h2 id="Defining_a_font">Defining a font</h2>

<p>There are some ingredients required for embedding a font in SVG. Let's show an example declaration (the one <a class="external" href="http://www.w3.org/TR/SVG/fonts.html#FontElement">from the specification</a>), and explain the details.</p>

<pre>&lt;font id="Font1" horiz-adv-x="1000"&gt;
  &lt;font-face font-family="Super Sans" font-weight="bold" font-style="normal"
      units-per-em="1000" cap-height="600" x-height="400"
      ascent="700" descent="300"
      alphabetic="0" mathematical="350" ideographic="400" hanging="500"&gt;
    &lt;font-face-src&gt;
      &lt;font-face-name name="Super Sans Bold"/&gt;
    &lt;/font-face-src&gt;
  &lt;/font-face&gt;
  &lt;missing-glyph&gt;&lt;path d="M0,0h200v200h-200z"/&gt;&lt;/missing-glyph&gt;
  &lt;glyph unicode="!" horiz-adv-x="300"&gt;&lt;!-- Outline of exclam. pt. glyph --&gt;&lt;/glyph&gt;
  &lt;glyph unicode="@"&gt;&lt;!-- Outline of @ glyph --&gt;&lt;/glyph&gt;
  &lt;!-- more glyphs --&gt;
&lt;/font&gt;
</pre>

<p>We start with the {{ SVGElement("font") }} element. This bears an id attribute, to enable it to be referenced via a URI (see below). The <code>horiz-adv-x</code> attribute determines how wide a character is on average compared to the path definitions of the single glyphs. The value <code>1000</code> sets a reasonable value to work with. There are several accompanying attributes that help further define the basic glyph-box layout.</p>

<p>The {{ SVGElement("font-face") }} element is the SVG equivalent of the CSS <a href="/en/CSS/@font-face" title="en/css/@font-face"><code>@font-face</code></a> declaration. It defines basic properties of the final font such as weight, style, etc. In the example above the first and most important to be defined is <code>font-family</code>, the value of which can then be referenced in CSS and SVG <code>font-family</code> properties. The <code>font-weight</code> and <code>font-style</code> attributes have the same purpose as the equivalent descriptors in CSS. All following attributes are rendering instructions for the font layout engine, for example, how much of the glyphs' overall heights are <a class="external" href="http://en.wikipedia.org/wiki/Ascender_%28typography%29" title="http://en.wikipedia.org/wiki/Ascender_(typography)">ascenders</a>.</p>

<p>Its child, the {{ SVGElement("font-face-src") }} element, corresponds to CSS' <code>src</code> descriptor in <code>@font-face</code> declarations. You can point to external sources for font declarations by means of its children {{ SVGElement("font-face-name") }} and {{ SVGElement("font-face-uri") }}. The above example states that if the renderer has a local font available named "Super Sans Bold", it should use this instead.</p>

<p>Following {{ SVGElement("font-face-src") }} is a {{ SVGElement("missing-glyph") }} element. This defines what should be displayed if a certain glyph is not found in the font and if there are no fallback mechanisms. It also shows how glyphs are created: By adding any graphical SVG content inside. You can use literally any other SVG elements in here, even {{ SVGElement("filter") }}, {{ SVGElement("a") }} or {{ SVGElement("script") }}. For simple glyphs, however, you can add a <code>d</code> attribute — this defines a shape for the glyph exactly like how standard SVG paths work.</p>

<p>The actual glyphs are then defined by {{ SVGElement("glyph") }} elements. The most important attribute is <code>unicode</code>. It defines the unicode codepoint represented by this glyph. If you also specify the {{htmlattrxref("lang")}} attribute on a glyph, you can further restrict it to certain languages (represented by <code>xml:lang</code> on the target) exclusively. Again, you can use arbitrary SVG to define the glyph, which allows for great effects in supporting user agents.</p>

<p>There are two further elements that can be defined inside <code>font</code>: {{ SVGElement("hkern") }} and {{ SVGElement("vkern") }}. Each carries references to at least two characters (attributes <code>u1</code> and <code>u2</code>) and an attribute <code>k</code> that determines how much the distance between those characters should be decreased. The below example instructs user agents to place the "A" and "V" characters closer together the standard distance between characters.</p>

<pre>&lt;hkern u1="A" u2="V" k="20" /&gt;
</pre>

<h2 id="Referencing_a_font">Referencing a font</h2>

<p>When you have put together your font declaration as described above, you can just use a simple <code>font-family</code> attribute to actually apply the font to some SVG text:</p>

<pre>&lt;font&gt;
  &lt;font-face font-family="Super Sans" /&gt;
  &lt;!-- and so on --&gt;
&lt;/font&gt;

&lt;text font-family="Super Sans"&gt;My text uses Super Sans&lt;/text&gt;
</pre>

<p>However, you are free to combine several methods for great freedom of how and where to define the font.</p>

<h3 id="Option_Use_CSS_font-face">Option: Use CSS @font-face</h3>

<p>You can use <code>@font-face</code> to reference remote (and not so remote) fonts:</p>

<pre>&lt;font id="Super_Sans"&gt;
  &lt;!-- and so on --&gt;
&lt;/font&gt;

&lt;style type="text/css"&gt;
@font-face {
  font-family: "Super Sans";
  src: url(#Super_Sans);
}
&lt;/style&gt;

&lt;text font-family="Super Sans"&gt;My text uses Super Sans&lt;/text&gt;</pre>

<h3 id="Option_reference_a_remote_font">Option: reference a remote font</h3>

<p>The above mentioned <code>font-face-uri</code> element allows you to reference an external font, hence allowing greater re-usability:</p>

<pre>&lt;font&gt;
  &lt;font-face font-family="Super Sans"&gt;
    &lt;font-face-src&gt;
      &lt;font-face-uri xlink:href="fonts.svg#Super_Sans" /&gt;
    &lt;/font-face-src&gt;
  &lt;/font-face&gt;
&lt;/font&gt;
</pre>

<p>{{ PreviousNext("Web/SVG/Tutorial/Filter_effects", "Web/SVG/Tutorial/SVG_Image_Tag") }}</p>
